Index: branches/MESI/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/MESI/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 719)
+++ branches/MESI/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 785)
@@ -2001,9 +1781,9 @@
                 }
 
-                if ( p_vci_tgt.cmdval and m_cmd_read_addr_fifo.wok() )
+                if (p_vci_tgt.cmdval and m_cmd_read_addr_fifo.wok() )
                 {
 
 #if DEBUG_MEMC_TGT_CMD
-                    if(m_debug)
+                    if (m_debug)
                         std::cout << "  <MEMC " << name() << " TGT_CMD_READ> Push into read_fifo:"
                             << " address = " << std::hex << p_vci_tgt.address.read()
@@ -2016,29 +1796,40 @@
                     // <Activity counters>
                     if (p_vci_tgt.cmd.read() == vci_param_int::CMD_LOCKED_READ) {
-                        if (is_local_req(p_vci_tgt.srcid.read())) m_cpt_ll_local++;
-                        else                                      m_cpt_ll_remote++;
-                        m_cpt_ll_cost += req_distance(p_vci_tgt.srcid.read()); // LL on a single word
-                    }
-                    else {
-                        if ((p_vci_tgt.pktid.read() & 0x7) == TYPE_WRITE)
-                        {
-                            if ((p_vci_tgt.pktid.read() & 0x8) == 0x8)
-                            {
-                                if (is_local_req(p_vci_tgt.srcid.read())) m_cpt_getm_hit_local++;
-                                else                                      m_cpt_getm_hit_remote++;
-                            }
-                            else
-                            {
-                                if (is_local_req(p_vci_tgt.srcid.read())) m_cpt_getm_miss_local++;
-                                else                                      m_cpt_getm_miss_remote++;
-                            }
-                            m_cpt_getm_cost += req_distance(p_vci_tgt.srcid.read());
+                        if (is_local_req(p_vci_tgt.srcid.read()))
+                        {
+                            m_cpt_ll_local++;
                         }
                         else
                         {
-                            if (is_local_req(p_vci_tgt.srcid.read())) m_cpt_read_miss_local++;
-                            else                                      m_cpt_read_miss_remote++;
-                            m_cpt_read_miss_cost += req_distance(p_vci_tgt.srcid.read());
-                        }
+                            m_cpt_ll_remote++;
+                        }
+                        // (1 (CMD) + 2 (RSP)) VCI flits for LL => 2 + 3 dspin flits
+                        m_cpt_ll_cost += 5 * req_distance(p_vci_tgt.srcid.read()); // LL on a single word
+                    }
+                    else if ((p_vci_tgt.pktid.read() & 0x7) == TYPE_WRITE)
+                    {
+                        if (is_local_req(p_vci_tgt.srcid.read())) 
+                        {
+                            m_cpt_getm_local++;
+                        }
+                        else
+                        {
+                            m_cpt_getm_remote++;
+                        }
+                        // (1 (CMD) + m_words (RSP)) flits VCI => 2 + m_words + 1 flits dspin
+                        m_cpt_getm_cost += (3 + m_words) * req_distance(p_vci_tgt.srcid.read());
+                    }
+                    else
+                    {
+                        if (is_local_req(p_vci_tgt.srcid.read()))
+                        {
+                            m_cpt_read_local++;
+                        }
+                        else
+                        {
+                            m_cpt_read_remote++;
+                        }
+                        // (1 (CMD) + m_words (RSP)) flits VCI => 2 + m_words + 1 flits dspin
+                        m_cpt_read_cost += (3 + m_words) * req_distance(p_vci_tgt.srcid.read());
                     }
                     // </Activity counters>
@@ -2049,9 +1840,9 @@
                 ///////////////////
             case TGT_CMD_WRITE:
-                if(p_vci_tgt.cmdval and m_cmd_write_addr_fifo.wok())
-                {
-
+                if (p_vci_tgt.cmdval and m_cmd_write_addr_fifo.wok())
+                {
+                    uint32_t plen = p_vci_tgt.plen.read();
 #if DEBUG_MEMC_TGT_CMD
-                    if(m_debug)
+                    if (m_debug)
                         std::cout << "  <MEMC " << name() << " TGT_CMD_WRITE> Push into write_fifo:"
                             << " address = " << std::hex << p_vci_tgt.address.read()
@@ -2061,15 +1852,23 @@
                             << " / wdata = " << p_vci_tgt.wdata.read()
                             << " / be = " << p_vci_tgt.be.read()
-                            << " / plen = " << std::dec << p_vci_tgt.plen.read() << std::endl;
+                            << " / plen = " << std::dec << plen << std::endl;
 #endif
                     cmd_write_fifo_put = true;
                     // <Activity counters>
                     if (p_vci_tgt.cmd.read() == vci_param_int::CMD_NOP) {
-                        m_cpt_sc_cost += req_distance(p_vci_tgt.srcid.read());
+                        // (2 (CMD) + 1 (RSP)) flits VCI => 4 + (1 (success) || 2 (failure)) flits dspin
+                        m_cpt_sc_cost += 5 * req_distance(p_vci_tgt.srcid.read());
                     }
                     else {
-                        if (is_local_req(p_vci_tgt.srcid.read())) m_cpt_write_flits_local++;
-                        else                                      m_cpt_write_flits_remote++;
-                        m_cpt_write_cost += req_distance(p_vci_tgt.srcid.read());
+                        if (is_local_req(p_vci_tgt.srcid.read()))
+                        {
+                            m_cpt_write_flits_local++;
+                        }
+                        else 
+                        {
+                            m_cpt_write_flits_remote++;
+                        }
+                        // (burst_size (CMD) + 1 (RSP) flits VCI => 2 + burst_size + 1 flits dspin
+                        m_cpt_write_cost += (3 + (plen >> 2)) * req_distance(p_vci_tgt.srcid.read());
                     }
                     // </Activity counters>
@@ -2078,11 +1877,22 @@
                         // <Activity counters>
                         if (p_vci_tgt.cmd.read() == vci_param_int::CMD_NOP) {
-                            if (is_local_req(p_vci_tgt.srcid.read())) m_cpt_sc_local++;
-                            else                                      m_cpt_sc_remote++;
-
+                            if (is_local_req(p_vci_tgt.srcid.read())) 
+                            {
+                                m_cpt_sc_local++;
+                            }
+                            else
+                            {
+                                m_cpt_sc_remote++;
+                            }
                         }
                         else {
-                            if (is_local_req(p_vci_tgt.srcid.read())) m_cpt_write_local++;
-                            else                                      m_cpt_write_remote++;
+                            if (is_local_req(p_vci_tgt.srcid.read())) 
+                            {
+                                m_cpt_write_local++;
+                            }
+                            else
+                            {
+                                m_cpt_write_remote++;
+                            }
                         }
                         // </Activity counters>
@@ -2093,5 +1903,5 @@
                 /////////////////
             case TGT_CMD_CAS:
-                if((p_vci_tgt.plen.read() != 8) and (p_vci_tgt.plen.read() != 16))
+                if ((p_vci_tgt.plen.read() != 8) and (p_vci_tgt.plen.read() != 16))
                 {
                     std::cout << "VCI_MEM_CACHE ERROR " << name() << " TGT_CMD_CAS state"
@@ -2100,9 +1910,9 @@
                 }
 
-                if(p_vci_tgt.cmdval and m_cmd_cas_addr_fifo.wok())
+                if (p_vci_tgt.cmdval and m_cmd_cas_addr_fifo.wok())
                 {
 
 #if DEBUG_MEMC_TGT_CMD
-                    if(m_debug)
+                    if (m_debug)
                         std::cout << "  <MEMC " << name() << " TGT_CMD_CAS> Pushing command into cmd_cas_fifo:"
                             << " address = " << std::hex << p_vci_tgt.address.read()
@@ -2117,7 +1927,14 @@
                     if (p_vci_tgt.eop) {
                         // <Activity counters>
-                        if (is_local_req(p_vci_tgt.srcid.read())) m_cpt_cas_local++;
-                        else                                      m_cpt_cas_remote++;
-                        m_cpt_cas_cost += req_distance(p_vci_tgt.srcid.read());
+                        if (is_local_req(p_vci_tgt.srcid.read()))
+                        {
+                            m_cpt_cas_local++;
+                        }
+                        else
+                        {
+                            m_cpt_cas_remote++;
+                        }
+                        // (2 (CMD) + 1 (RSP)) flits VCI => 4 + (1 (success) || 2 (failure)) flits dspin
+                        m_cpt_cas_cost += 5 * req_distance(p_vci_tgt.srcid.read());
                         // </Activity counters>
                         r_tgt_cmd_fsm = TGT_CMD_IDLE;
@@ -2151,14 +1968,14 @@
                     uint64_t flit = m_cc_receive_to_multi_ack_fifo.read();
 
-                    if( not multi_ack_fifo_rok )
+                    if (not multi_ack_fifo_rok)
                         break;
 
-                    size_t ivt_index    = DspinDhccpParam::dspin_get(flit,
-                                    DspinDhccpParam::MULTI_ACK_UPDT_INDEX);
-
-                    bool miss_updt    = DspinDhccpParam::dspin_get(flit,
-                                    DspinDhccpParam::MULTI_ACK_UPDT_MISS);
-
-                    bool eop = DspinDhccpParam::dspin_get(flit, DspinDhccpParam::P2M_EOP) == 0x1;
+                    size_t ivt_index = DspinHmesiParam::dspin_get(flit,
+                                    DspinHmesiParam::MULTI_ACK_UPDT_INDEX);
+
+                    bool miss_updt = DspinHmesiParam::dspin_get(flit,
+                                    DspinHmesiParam::MULTI_ACK_UPDT_MISS);
+
+                    bool eop = DspinHmesiParam::dspin_get(flit, DspinHmesiParam::P2M_EOP) == 0x1;
 
                     cc_receive_to_multi_ack_fifo_get = true;
@@ -2171,24 +1988,18 @@
                     r_multi_ack_miss_updt = miss_updt;
 
-                    if(miss_updt)
-                        m_cpt_multi_ack_miss ++;
-                    else
-                        m_cpt_multi_ack_hit ++;
-
-                    if( not eop)
-                    {
-                        r_multi_ack_fsm = MULTI_ACK_GET_DATA;
+                    if (not eop)
+                    {
                         r_multi_ack_need_data = true;
                         r_multi_ack_data_index = 0;
-                        m_cpt_multi_ack_hit_with_data ++;
+                        r_multi_ack_fsm = MULTI_ACK_GET_DATA;
                     }
                     else
                     {
+                        r_multi_ack_need_data = false;
                         r_multi_ack_fsm = MULTI_ACK_DIR_REQ;
-                        r_multi_ack_need_data = false;
                     }
 
 #if DEBUG_MEMC_MULTI_ACK
-                    if(m_debug)
+                    if (m_debug)
                     {
                         if (multi_ack_fifo_rok)
@@ -2211,9 +2022,9 @@
 
                         uint32_t data = 
-                            DspinDhccpParam::dspin_get (flit, DspinDhccpParam::CLEANUP_DATA_UPDT);
-
-                        bool eop = DspinDhccpParam::dspin_get(flit, DspinDhccpParam::P2M_EOP) == 0x1;
+                            DspinHmesiParam::dspin_get (flit, DspinHmesiParam::CLEANUP_DATA_UPDT);
+
+                        bool eop = DspinHmesiParam::dspin_get(flit, DspinHmesiParam::P2M_EOP) == 0x1;
 #if DEBUG_MEMC_CLEANUP
-                        if(m_debug)
+                        if (m_debug)
                         {
                             std::cout
@@ -2242,13 +2053,10 @@
             case MULTI_ACK_IVT_LOCK:
                 {
-                    m_cpt_multi_ack_fsm_ivt_lock ++;
-                    if(r_alloc_ivt_fsm.read() != ALLOC_IVT_MULTI_ACK)  break;
-
-                    m_cpt_multi_ack_fsm_n_ivt_lock ++;
+                    if (r_alloc_ivt_fsm.read() != ALLOC_IVT_MULTI_ACK)  break;
 
                     assert( r_alloc_dir_fsm.read() == ALLOC_DIR_MULTI_ACK && " BAD ALLOC_DIR_MULTI_ACK IN MULTI_ACK_IVT_LOCK STATE");
-                    size_t index  = r_multi_ack_ivt_index.read();
-                    size_t count  = m_ivt.count(index);
-                    size_t nline  = m_ivt.nline(index);
+                    size_t index = r_multi_ack_ivt_index.read();
+                    size_t count = m_ivt.count(index);
+                    size_t nline = m_ivt.nline(index);
                     r_multi_ack_nline = nline;
                     r_multi_ack_srcid = m_ivt.srcid(index);
@@ -2256,21 +2064,52 @@
                     r_multi_ack_pktid = m_ivt.pktid(index);
                     r_multi_ack_rsp   = m_ivt.need_rsp(index);
-                    //bool is_valid = m_ivt.is_valid(index);
-
-                    // if(r_multi_ack_miss_updt.read())
-                    //{
-                        r_multi_ack_fsm = MULTI_ACK_DIR_LOCK; // this way may be bring about the problem of critical path
-                    //}                    
-                    //else
-                    //{
-                        bool is_updt  = m_ivt.is_update(index);
+                    uint32_t srcid = m_ivt.srcid(index);
                     
-                        assert(is_updt && "MULTI_ACK: is not an updt index for a multi ack rsp");
-                        assert(count == 1 && "there is only one copy in the memc");
-
-                    //  r_multi_ack_fsm = MULTI_ACK_IVT_CLEAR;
+                    // <Activity Counters>
+                    // We count "read-only invalidations" at the same place as
+                    // multi ack.
+                    // The idea is that a RO inval is always responded by a multi ack,
+                    // and that a multi ack is sent only for inval RO.
+                    // Thus, we add one to the cost for the inval RO fleet, and
+                    // depending on the response, we add either 1 or m_words + 1 for the cost for the multi ack flits
+                    if (r_multi_ack_need_data.read())
+                    {
+                        // multi_ack with data
+                        if (is_local_req(srcid))
+                        {
+                            m_cpt_inval_ro_local++;
+                        }
+                        else
+                        {
+                            m_cpt_inval_ro_remote++;
+                        }
+                        // 2 flits for inval RO + (m_words + 1) flits for the multi ack
+                        m_cpt_inval_ro_cost += (m_words + 1) * req_distance(srcid);
+                    }
+                    else
+                    {
+                        // multi_ack without data
+                        if (is_local_req(srcid))
+                        {
+                            m_cpt_inval_ro_local++;
+                        }
+                        else
+                        {
+                            m_cpt_inval_ro_remote++;
+                        }
+                        // 2 flits for inval RO + 1 flit for the multi ack
+                        m_cpt_inval_ro_cost += 3 * req_distance(srcid); // 1 flit
+                    }
+                    // </Activity Counters>
+
+
+                    r_multi_ack_fsm = MULTI_ACK_DIR_LOCK; // this way may be bring about the problem of critical path
+                    bool is_updt  = m_ivt.is_update(index);
+                    
+                    assert(is_updt && "MULTI_ACK: is not an updt index for a multi ack rsp");
+                    assert(count == 1 && "there is only one copy in the memc");
 
 #if DEBUG_MEMC_MULTI_ACK
-                    if(m_debug)
+                    if (m_debug)
                         std::cout << "  <MEMC " << name()
                             << " MULTI_ACK_IVT_LOCK> "
@@ -2283,5 +2122,5 @@
             case MULTI_ACK_IVT_CLEAR:
                 {
-                    if(r_alloc_ivt_fsm.read() != ALLOC_IVT_MULTI_ACK ) 
+                    if (r_alloc_ivt_fsm.read() != ALLOC_IVT_MULTI_ACK ) 
                     {
                         std::cout
@@ -2297,5 +2136,5 @@
             
 #if DEBUG_MEMC_MULTI_ACK
-                    if(m_debug)
+                    if (m_debug)
                         std::cout << "  <MEMC " << name()
                             << " MULTI_ACK_IVT_CLEAR> IVT clear:"
@@ -2308,13 +2147,11 @@
             case MULTI_ACK_DIR_REQ:   // Get the lock to the directory
                 {
-                    m_cpt_multi_ack_fsm_dir_lock ++;
-                    if(r_alloc_dir_fsm.read() != ALLOC_DIR_MULTI_ACK) break;
+                    if (r_alloc_dir_fsm.read() != ALLOC_DIR_MULTI_ACK) break;
 
                     r_multi_ack_fsm = MULTI_ACK_IVT_LOCK;
                     //std::cout << " MEM_CACHE : CLEANUP_DIR_REQ" << std::endl;
-                    m_cpt_multi_ack_fsm_n_dir_lock ++;
 
 #if DEBUG_MEMC_CLEANUP
-                    if(m_debug)
+                    if (m_debug)
                         std::cout << "  <MEMC " << name() << " MULTI_ACK_DIR_REQ> Requesting DIR lock" << std::endl;
 #endif
@@ -2325,5 +2162,5 @@
             case MULTI_ACK_DIR_LOCK: //updt data with the registers which have saved the set and way
                 {
-                    if(r_alloc_dir_fsm.read() != ALLOC_DIR_MULTI_ACK)
+                    if (r_alloc_dir_fsm.read() != ALLOC_DIR_MULTI_ACK)
                     {
                         std::cout
@@ -2349,5 +2186,5 @@
 
 #if DEBUG_MEMC_MULTI_ACK
-                    if(m_debug)
+                    if (m_debug)
                     {
                         std::cout
@@ -2365,25 +2202,25 @@
                     }
 #endif
-                    assert( (entry.state == ENTRY_LOCKED) && "mutli rsp check the entry, the line is not locked!!!");
+                    assert((entry.state == ENTRY_LOCKED) && "multi rsp check the entry, the line is not locked!!!");
                         
-                    if(r_multi_ack_miss_updt.read() and entry.count) //cache L1 has sent the cleanup when it receives the cc_updt request,
+                    if (r_multi_ack_miss_updt.read() and entry.count) //cache L1 has sent the cleanup when it receives the cc_updt request,
                     {
                         r_multi_ack_fsm = MULTI_ACK_IVT_CHANGE; 
                     }
-                    else if( not entry.count or match_ll) // The line has been already evicted from cache L1
+                    else if (not entry.count or match_ll) // The line has been already evicted from cache L1
                     {
                         assert(((entry.count == 1) or (entry.count == 0)) && "multi ack for a ll request, count is 1");
-                        r_multi_ack_fsm        = MULTI_ACK_DIR_UPDT;
+                        r_multi_ack_fsm = MULTI_ACK_DIR_UPDT;
                     }
                     else
                     {
-                        r_multi_ack_fsm        = MULTI_ACK_HEAP_REQ;
+                        r_multi_ack_fsm = MULTI_ACK_HEAP_REQ;
                     }
                     break;
                 }
                 /////////////
-            case MULTI_ACK_IVT_CHANGE:   // release all locks and retry from beginning
+            case MULTI_ACK_IVT_CHANGE:
                 {                  
-                    if(r_alloc_ivt_fsm.read() != ALLOC_IVT_MULTI_ACK ) 
+                    if (r_alloc_ivt_fsm.read() != ALLOC_IVT_MULTI_ACK) 
                     {
                         std::cout
@@ -2396,5 +2233,5 @@
                     m_ivt.change(r_multi_ack_ivt_index.read());
 #if DEBUG_MEMC_MULTI_ACK
-                    if(m_debug)
+                    if (m_debug)
                     {
                         std::cout << "  <MEMC " << name()
@@ -2408,5 +2245,5 @@
             case MULTI_ACK_DIR_UPDT:
                 {
-                    if(r_alloc_dir_fsm.read() != ALLOC_DIR_MULTI_ACK)
+                    if (r_alloc_dir_fsm.read() != ALLOC_DIR_MULTI_ACK)
                     {
                         std::cout
@@ -2420,7 +2257,7 @@
                     bool match_ll = ((r_multi_ack_pktid.read() & 0x07) == TYPE_LL);
 
-                    if(r_multi_ack_need_data.read())
-                    {
-                        for(size_t word=0; word<m_words ; word++)
+                    if (r_multi_ack_need_data.read())
+                    {
+                        for (size_t word = 0; word<m_words; word++)
                         {
                             m_cache_data.write(r_multi_ack_way.read(), 
@@ -2429,45 +2266,33 @@
                                                r_multi_ack_data[word]);
                         }
-                       // addr_t min = r_multi_ack_nline.read()*m_words*4 ;
-                       // addr_t max = r_multi_ack_nline.read()*m_words*4 + (m_words - 1)*4;
-                       // m_llsc_table.sw(min, max);
- 
                     }
                     else
                     {
-                        m_cache_data.read_line( r_multi_ack_way.read(),
-                                                r_multi_ack_set.read(),
-                                                r_multi_ack_data);
+                        m_cache_data.read_line(r_multi_ack_way.read(),
+                                               r_multi_ack_set.read(),
+                                               r_multi_ack_data);
                     }
 
                     DirectoryEntry entry;
-                    entry.is_cnt         = false;
-                    entry.dirty          = r_multi_ack_dirty.read() or r_multi_ack_need_data.read();
-                    entry.tag            = r_multi_ack_tag.read();
-                    entry.lock           = r_multi_ack_lock.read();
-                    entry.ptr            = 0;
-
-                    if(match_ll)
-                    {
-                        entry.owner.srcid    = r_multi_ack_copy.read();
-                        entry.count          = r_multi_ack_count.read();
+                    entry.is_cnt = false;
+                    entry.dirty  = r_multi_ack_dirty.read() or r_multi_ack_need_data.read();
+                    entry.tag    = r_multi_ack_tag.read();
+                    entry.lock   = r_multi_ack_lock.read();
+                    entry.ptr    = 0;
+
+                    if (match_ll)
+                    {
+                        entry.owner.srcid = r_multi_ack_copy.read();
+                        entry.count       = r_multi_ack_count.read();
                     }
                     else
                     {
-                        entry.owner.srcid    = r_multi_ack_srcid.read();
-                        entry.count          = 1;
-                    }
-
-
-                   // if( (r_multi_ack_pktid.read() & 0x07) == 0x03 or match_ll)
-                   // {
-                        entry.state          = ENTRY_SHARED; // MISS INST
-                   // }
-                   //  else
-                   //  {
-                   //     entry.state          = ENTRY_EXCLUSIVE; // MISS DATA 
-                   // }
-
-                    if((r_multi_ack_pktid.read() & 0x7) == 0x03) 
+                        entry.owner.srcid = r_multi_ack_srcid.read();
+                        entry.count       = 1;
+                    }
+
+                    entry.state = ENTRY_SHARED; // MISS INST
+
+                    if ((r_multi_ack_pktid.read() & 0x7) == 0x03) 
                     {
                         entry.owner.inst = true;
@@ -2483,5 +2308,5 @@
                     r_multi_ack_fsm      = MULTI_ACK_IVT_CLEAR;
 #if DEBUG_MEMC_MULTI_ACK
-                    if(m_debug)
+                    if (m_debug)
                     {
                         std::cout << "  <MEMC " << name() << " MULTI_ACK_DIR_UPDT>"
@@ -2499,41 +2324,33 @@
                 // wait if pending request to the TGT_RSP FSM
                 {
-                    if(r_multi_ack_to_tgt_rsp_req.read()) break;
-
-                    for(size_t i = 0; i<m_words; i++)
+                    if (r_multi_ack_to_tgt_rsp_req.read()) break;
+
+                    for (size_t i = 0; i<m_words; i++)
                     {
                         r_multi_ack_to_tgt_rsp_data[i] = r_multi_ack_data[i].read();
                     }
                     // no pending request
-                    r_multi_ack_to_tgt_rsp_req     = true;
-                    if( r_read_to_multi_ack_req.read() and (r_read_to_multi_ack_nline.read() == r_multi_ack_nline.read()))
-                    {
-                        r_multi_ack_to_tgt_rsp_word    = r_read_to_multi_ack_first_word.read();
-                        r_multi_ack_to_tgt_rsp_length  = r_read_to_multi_ack_length.read();
-                        r_read_to_multi_ack_req        = false;
+                    r_multi_ack_to_tgt_rsp_req = true;
+                    if (r_read_to_multi_ack_req.read() and (r_read_to_multi_ack_nline.read() == r_multi_ack_nline.read()))
+                    {
+                        r_multi_ack_to_tgt_rsp_word   = r_read_to_multi_ack_first_word.read();
+                        r_multi_ack_to_tgt_rsp_length = r_read_to_multi_ack_length.read();
+                        r_read_to_multi_ack_req       = false;
                     }
                     else
                     {
-                        r_multi_ack_to_tgt_rsp_word    = 0;
-                        r_multi_ack_to_tgt_rsp_length  = 16;
-                    }
-
-                    r_multi_ack_to_tgt_ll_key      = r_read_to_multi_ack_ll_key.read();
-                    r_multi_ack_to_tgt_rsp_srcid   = r_multi_ack_srcid.read();
-                    r_multi_ack_to_tgt_rsp_trdid   = r_multi_ack_trdid.read();
-
-                   // if(r_multi_ack_rsp_shared.read()) // rsp read with shared or exclusive state
-                   // {
-                        r_multi_ack_to_tgt_rsp_pktid = r_multi_ack_pktid.read();
-                   // }
-                   // else
-                   //{
-                   //    r_multi_ack_to_tgt_rsp_pktid = 0x08 + r_multi_ack_pktid.read();  
-                   //}
-
-                   r_multi_ack_fsm = MULTI_ACK_IDLE;
+                        r_multi_ack_to_tgt_rsp_word   = 0;
+                        r_multi_ack_to_tgt_rsp_length = 16;
+                    }
+
+                    r_multi_ack_to_tgt_ll_key    = r_read_to_multi_ack_ll_key.read();
+                    r_multi_ack_to_tgt_rsp_srcid = r_multi_ack_srcid.read();
+                    r_multi_ack_to_tgt_rsp_trdid = r_multi_ack_trdid.read();
+                    r_multi_ack_to_tgt_rsp_pktid = r_multi_ack_pktid.read();
+
+                    r_multi_ack_fsm = MULTI_ACK_IDLE;
 
 #if DEBUG_MEMC_MULTI_ACK
-                    if(m_debug)
+                    if (m_debug)
                         std::cout << "  <MEMC " << name() << " MULTI_ACK_RSP>"
                             << " Send a response to a previous read/ll request: "
@@ -2553,13 +2370,11 @@
             case MULTI_ACK_HEAP_REQ:    // Get the lock to the HEAP directory
                 {
-                    m_cpt_multi_ack_fsm_n_heap_lock ++;
-                    if(r_alloc_heap_fsm.read() == ALLOC_HEAP_MULTI_ACK)
+                    if (r_alloc_heap_fsm.read() == ALLOC_HEAP_MULTI_ACK)
                     {
                         r_multi_ack_fsm = MULTI_ACK_HEAP_LOCK;
                     }
 
-                    m_cpt_multi_ack_fsm_heap_lock ++;
 #if DEBUG_MEMC_MULTI_ACK
-                    if(m_debug)
+                    if (m_debug)
                         std::cout << "  <MEMC " << name() << " MULTI_ACK_HEAP_REQ>"
                             << " Requesting HEAP lock " << std::endl;
@@ -2571,10 +2386,10 @@
                 // and prepare the HEAP update
                 {
-                    if(r_alloc_heap_fsm.read() == ALLOC_HEAP_MULTI_ACK and 
+                    if (r_alloc_heap_fsm.read() == ALLOC_HEAP_MULTI_ACK and 
                        r_alloc_dir_fsm.read() == ALLOC_DIR_MULTI_ACK)
                     {
-                        if(r_multi_ack_need_data.read())
-                        {
-                            for(size_t word=0; word<m_words ; word++)
+                        if (r_multi_ack_need_data.read())
+                        {
+                            for (size_t word = 0; word < m_words ; word++)
                             {
                                 m_cache_data.write(r_multi_ack_way.read(), 
@@ -2583,15 +2398,10 @@
                                                    r_multi_ack_data[word]);
                             }
-
-                           // addr_t min = r_multi_ack_nline.read()*m_words*4 ;
-                           // addr_t max = r_multi_ack_nline.read()*m_words*4 + (m_words - 1)*4;
-                           // m_llsc_table.sw(min, max);
- 
                         }
                         else
                         {
-                            m_cache_data.read_line( r_multi_ack_way.read(),
-                                                    r_multi_ack_set.read(),
-                                                    r_multi_ack_data);
+                            m_cache_data.read_line(r_multi_ack_way.read(),
+                                                   r_multi_ack_set.read(),
+                                                   r_multi_ack_data);
                         }
 
@@ -2606,15 +2416,15 @@
                         entry.dirty  = r_multi_ack_dirty.read() or r_multi_ack_need_data.read();
                         entry.tag    = r_multi_ack_tag.read();
-                        if(not go_cnt)         // Not entering counter mode
-                        {
-                            entry.owner.srcid      = r_multi_ack_copy.read();
-                            entry.owner.inst       = r_multi_ack_copy_inst.read();
-                            entry.ptr              = m_heap.next_free_ptr();   // set pointer on the heap
-
-                            HeapEntry heap_entry   = m_heap.next_free_entry();
-
-                            r_multi_ack_next_ptr   = heap_entry.next;
-                            r_multi_ack_last_free  = (heap_entry.next == m_heap.next_free_ptr());
-                            r_multi_ack_fsm        = MULTI_ACK_HEAP_WRITE; // add an entry in the HEAP
+                        if (not go_cnt)         // Not entering counter mode
+                        {
+                            entry.owner.srcid = r_multi_ack_copy.read();
+                            entry.owner.inst  = r_multi_ack_copy_inst.read();
+                            entry.ptr         = m_heap.next_free_ptr();   // set pointer on the heap
+
+                            HeapEntry heap_entry = m_heap.next_free_entry();
+
+                            r_multi_ack_next_ptr  = heap_entry.next;
+                            r_multi_ack_last_free = (heap_entry.next == m_heap.next_free_ptr());
+                            r_multi_ack_fsm       = MULTI_ACK_HEAP_WRITE; // add an entry in the HEAP
                         }
                         else                // Entering Counter mode
